import Vue from 'vue'
import VueRouter from 'vue-router'
import Store from '../store'
import Index from '../views/Index.vue'


const originalPush = VueRouter.prototype.push
VueRouter.prototype.push = function push(location, onResolve, onReject) {
  if (onResolve || onReject) return originalPush.call(this, location, onResolve, onReject)
  return originalPush.call(this, location).catch(err => err)
}

Vue.use(VueRouter)

const routes = [{
		path: '/',
		name: 'Home',
		component: Index
	},
	{
	  path: '/cart',
	  name: 'Cart',
	  // route level code-splitting
	  // this generates a separate chunk (about.[hash].js) for this route
	  // which is lazy-loaded when the route is visited.
	  component: () => import(/* webpackChunkName: "about" */ '../views/Cart.vue')
	},
	{
	  path: '/product/:id',
	  name: 'Product',
	  // route level code-splitting
	  // this generates a separate chunk (about.[hash].js) for this route
	  // which is lazy-loaded when the route is visited.
	  component: () => import(/* webpackChunkName: "about" */ '../views/Product.vue')
	},
	{
	  path: '/login',
	  name: 'Login',
	  // route level code-splitting
	  // this generates a separate chunk (about.[hash].js) for this route
	  // which is lazy-loaded when the route is visited.
	  component: () => import(/* webpackChunkName: "about" */ '../views/Login.vue')
	}
]


const router = new VueRouter({
	mode: 'history',
	base: process.env.BASE_URL,
	routes
})

router.beforeEach((to, from, next) => {
	
	if(['Product','List'].findIndex(v => v == to.name) != -1){
		if(!Store.state.user){
			next({ path: '/login'})
		}
	}
	next()	
	
})

export default router
